/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex03;

import ej.microui.Colors;
import ej.microui.io.DisplayFont;
import ej.microui.io.GraphicsContext;
import ej.mwt.Renderable;
import ej.mwt.Widget;
import ej.mwt.rendering.WidgetRenderer;

public class ButtonRenderer extends WidgetRenderer {

	public Class getManagedType() {
		return Button.class;
	}

	public int getPreferredContentWidth(Widget widget) {
		Button button = (Button) widget;
		String text = button.getText();
		return DisplayFont.getDefaultFont().stringWidth(text);
	}

	public int getPreferredContentHeight(Widget widget) {
		return DisplayFont.getDefaultFont().getHeight();
	}

	public void render(GraphicsContext g, Renderable renderable) {
		Button button = (Button) renderable;
		g.setColor(Colors.WHITE);
		g.fillRect(0, 0, button.getWidth(), button.getHeight());
		g.setColor(Colors.BLACK);
		g.drawString(button.getText(), button.getWidth() / 2, button.getHeight() / 2,
				GraphicsContext.HCENTER | GraphicsContext.VCENTER);
		if (button.hasFocus()) {
			g.setStrokeStyle(GraphicsContext.DOTTED);
			g.drawRect(1, 1, button.getWidth()-3, button.getHeight()-3);
		}
	}

	public int getPadding() {
		return 4;
	}
}
