/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex06;

import ej.mwt.Composite;
import ej.mwt.Widget;

public class HorizontalStack extends Composite {

	public void validate(int widthHint, int heightHint) {
		Widget[] widgets = getWidgets();
		int totalWidth = 0;
		int maxHeight = 0;
		for (int i = 0; i < widgets.length; i++) {
			Widget widget = widgets[i];
			widget.validate(0, heightHint);
			widget.setBounds(totalWidth, 0, widget.getPreferredWidth(), widget.getPreferredHeight());
			totalWidth += widget.getPreferredWidth();
			maxHeight = Math.max(maxHeight, widget.getPreferredHeight());
		}
		setPreferredSize(totalWidth, maxHeight);
	}
}
