/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex07;

import ej.microui.Colors;
import ej.microui.io.GraphicsContext;
import ej.mwt.Renderable;
import ej.mwt.Widget;
import ej.mwt.rendering.Renderer;

public class HorizontalStackRenderer extends Renderer {
	
	public Class getManagedType() {
		return HorizontalStack.class;
	}

	public void render(GraphicsContext g, Renderable renderable) {
		HorizontalStack composite = (HorizontalStack) renderable;
		Widget[] widgets = composite.getWidgets();
		g.setColor(Colors.RED);
		for (int i = 0; i < widgets.length; i++) {
			Widget widget = widgets[i];
			Renderer widgetRenderer = widget.getRenderer();
			int widgetMargin = widgetRenderer==null ? 0 : widgetRenderer.getMargin();
			g.fillRect(widget.getX()-widgetMargin, widget.getY()-widgetMargin, widget.getWidth()+(widgetMargin*2), widget.getHeight()+(widgetMargin*2));
		}
	}

	public int getPadding() {
		return 6;
	}
}
