/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex08;

import ej.microui.Listener;
import ej.microui.MicroUI;
import ej.mwt.Composite;
import ej.mwt.Desktop;
import ej.mwt.MWT;
import ej.mwt.Panel;

public class Ex8 {

	public static void main(String[] args) {
		MicroUI.errorLog(true);
		MWT.RenderingContext.add(new TutorialTheme());
		Desktop desktop = new Desktop();
		Panel panel = new Panel();
		Composite rows = new VerticalStack();
		for (int rowNumber = 0; rowNumber < 3; rowNumber++) {
			Composite row = new HorizontalStack();
			for (int colNumber = 0; colNumber < 5; colNumber++) {
				final int buttonNumber = rowNumber*5 + colNumber;
				Button button = new Button("Button " + buttonNumber);
				button.setListener(new Listener() {
					public void performAction() {
						System.out.println("Button " + buttonNumber + " pressed");
					}
					public void performAction(int value) {}
					public void performAction(int value, Object object) {}
				});
				row.add(button);
			}
			rows.add(row);
		}
		panel.setWidget(rows);
		panel.show(desktop);
		desktop.show();
	}
}
