/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex08;

import ej.mwt.Composite;
import ej.mwt.Widget;
import ej.mwt.rendering.Renderer;

public class VerticalStack extends Composite {

	public void validate(int widthHint, int heightHint) {
		Widget[] widgets = getWidgets();
		int totalHeight = 0;
		int maxWidth = 0;
		Renderer myRenderer = getRenderer();
		int myPadding = myRenderer==null ? 0 : myRenderer.getPadding();
		widthHint -= myPadding * 2;
		for (int i = 0; i < widgets.length; i++) {
			Widget widget = widgets[i];
			Renderer widgetRenderer = widget.getRenderer();
			int widgetMargin = widgetRenderer==null ? 0 : widgetRenderer.getMargin();
			widget.validate(widthHint < (widgetMargin * 2) ? 0 : widthHint - (widgetMargin * 2), 0);
			widget.setBounds(myPadding + widgetMargin, totalHeight + myPadding + widgetMargin, widget.getPreferredWidth(), widget.getPreferredHeight());
			totalHeight += widget.getPreferredHeight() + (widgetMargin * 2) + myPadding;
			maxWidth = Math.max(maxWidth, widget.getPreferredWidth() + (widgetMargin * 2) + (myPadding * 2));
		}
		setPreferredSize(maxWidth, totalHeight + myPadding);
	}
}
