/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex09;

import ej.microui.Colors;
import ej.microui.io.DisplayFont;
import ej.microui.io.GraphicsContext;
import ej.mwt.Renderable;
import ej.mwt.Widget;
import ej.mwt.rendering.WidgetRenderer;

public class LabelRenderer extends WidgetRenderer {
	
	public Class getManagedType() {
		return Label.class;
	}

	public int getPreferredContentWidth(Widget widget) {
		Label label = (Label) widget;
		String text = label.getText();
		return DisplayFont.getDefaultFont().stringWidth(text);
	}

	public int getPreferredContentHeight(Widget widget) {
		return DisplayFont.getDefaultFont().getHeight();
	}

	public void render(GraphicsContext g, Renderable renderable) {
		Label label = (Label)renderable;
		g.setColor(Colors.WHITE);
		g.fillRect(0, 0, label.getWidth(), label.getHeight());
		g.setColor(Colors.BLACK);
		g.drawString(label.getText(), label.getWidth() / 2, label.getHeight() / 2,
				GraphicsContext.HCENTER | GraphicsContext.VCENTER);
	}

	public int getMargin() {
		return 2;
	}

	public int getPadding() {
		return 4;
	}
}
