/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex10;

import ej.microui.Listener;
import ej.microui.MicroUI;
import ej.mwt.Composite;
import ej.mwt.Desktop;
import ej.mwt.MWT;
import ej.mwt.Panel;

public class Ex10 {

	public static void main(String[] args) {
		MicroUI.errorLog(true);
		MWT.RenderingContext.add(new TutorialTheme());
		Desktop desktop = new Desktop();
		Panel panel = new Panel();
		Composite composite = new HorizontalStack();
		final TextHolder label = new Label("Here are the details");
		label.setVisible(false);
		final ToggleButton button = new ToggleButton("Show/Hide Details");
		button.setListener(new Listener() {
			public void performAction(int value) {
				System.out.println("Button is " + (value==0?"off":"on"));
				label.setVisible(value==0?false:true);
				label.revalidate();
			}
			public void performAction() {}
			public void performAction(int value, Object object) {}
		});
		ToggleButton enablingButton = new ToggleButton("Enable/Disable");
		enablingButton.setOn(true);
		enablingButton.setListener(new Listener() {
			public void performAction(int value) {
				button.setEnabled(value==0?false:true);
				button.repaint();
			}
			public void performAction() {}
			public void performAction(int value, Object object) {}
		});
		composite.add(label);
		composite.add(button);
		composite.add(enablingButton);
		panel.setWidget(composite);
		panel.show(desktop);
		desktop.show();
	}
}
