/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex10;

import ej.microui.io.DisplayFont;
import ej.microui.io.GraphicsContext;
import ej.mwt.Renderable;
import ej.mwt.Widget;
import ej.mwt.rendering.Look;
import ej.mwt.rendering.WidgetRenderer;

public class LabelRenderer extends WidgetRenderer {
	
	public Class getManagedType() {
		return Label.class;
	}

	public int getPreferredContentWidth(Widget widget) {
		TextHolder label = (TextHolder) widget;
		String text = label.getText();
		return getNormalFont().stringWidth(text);
	}

	public int getPreferredContentHeight(Widget widget) {
		return getNormalFont().getHeight();
	}

	public void render(GraphicsContext g, Renderable renderable) {
		TextHolder label = (TextHolder)renderable;
		g.setColor(getLook().getProperty(Look.GET_BACKGROUND_COLOR_CONTENT));
		g.fillRect(0, 0, label.getWidth(), label.getHeight());
		g.setColor(getLook().getProperty(Look.GET_FOREGROUND_COLOR_DEFAULT));
		g.setFont(getNormalFont());
		g.drawString(label.getText(), label.getWidth() / 2, label.getHeight() / 2,
				GraphicsContext.HCENTER | GraphicsContext.VCENTER);
	}

	public int getMargin() {
		return 2;
	}

	public int getPadding() {
		return 4;
	}

	private DisplayFont getNormalFont() {
		return getLook().getFonts()[getLook().getProperty(Look.GET_FONT_INDEX_DEFAULT)];
	}
}
