/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex10;

import ej.microui.Command;
import ej.microui.Event;
import ej.microui.Listener;
import ej.microui.io.Pointer;

public class ToggleButton extends TextHolder {

	private Listener listener;
	private boolean isOn;

	public ToggleButton(String text) {
		super(text);
		isOn = false;
	}
	
	public void setListener(Listener listener) {
		this.listener = listener;
	}

	public boolean isOn() {
		return isOn;
	}

	public void setOn(boolean isOn) {
		this.isOn = isOn;
		repaint();
	}

	public boolean handleEvent(int event) {
		int type = Event.getType(event);
		if (type == Event.POINTER) {
			int action = Pointer.getAction(event);
			if (action == Pointer.RELEASED) {
				updateToggle();
				return true;
			}
		}
		if(type == Event.COMMAND) {
			int command = Event.getData(event);
			if (command == Command.SELECT) {
				updateToggle();
				return true;
			}
		}
		return super.handleEvent(event);
	}

	private void updateToggle() {
		setOn(!isOn);
		if (listener != null)
			listener.performAction(isOn?1:0);
	}
}