/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex12;

import ej.microui.Colors;
import ej.microui.io.GraphicsContext;
import ej.mwt.Desktop;
import ej.mwt.Renderable;
import ej.mwt.rendering.Renderer;

public class DesktopRenderer extends Renderer {
	
	public Class getManagedType() {
		return Desktop.class;
	}

	public void render(GraphicsContext g, Renderable renderable) {
		int width = renderable.getWidth();
		int height = renderable.getHeight();
		fillVLinearGradient(g, 0, 0, width, height, Colors.BLUE, Colors.YELLOW, true);
	}

	private static final int FACTOR = 5;
	private static final void fillVLinearGradient(GraphicsContext g, int x, int y, int width, int height, int startColor, int stopColor, boolean horizontal) {
		int currentRed = ((startColor & 0xff0000) >>> 16) << FACTOR;
		int currentGreen = ((startColor & 0xff00) >>> 8) << FACTOR;
		int currentBlue = ((startColor & 0xff)) << FACTOR;

		int length = horizontal ? height : width;

		int stepRed = (currentRed - (((stopColor & 0xff0000) >>> 16) << FACTOR)) / length;
		int stepGreen = (currentGreen - (((stopColor & 0xff00) >>> 8) << FACTOR)) / length;
		int stepBlue = (currentBlue - ((stopColor & 0xff) << FACTOR)) / length;

		do {
			g.setColor((((currentRed >>> FACTOR) & 0xff) << 16) | (((currentGreen >>> FACTOR) & 0xff) << 8) | ((currentBlue >>> FACTOR) & 0xff));
			if(horizontal) g.drawHorizontalLine(x, y++, width);
			else g.drawVerticalLine(x++, y, height);
			currentRed -= stepRed;
			currentGreen -= stepGreen;
			currentBlue -= stepBlue;
		} while(--length >= 0);
	}
}
