/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex13;

import ej.mwt.Composite;
import ej.mwt.Widget;
import ej.mwt.rendering.Renderer;

public class HorizontalStack extends Composite {

	public void validate(int widthHint, int heightHint) {
		Widget[] widgets = getWidgets();
		int totalWidth = 0;
		int maxHeight = 0;
		Renderer myRenderer = getRenderer();
		int myPadding = myRenderer==null ? 0 : myRenderer.getPadding();
		heightHint -= myPadding * 2;
		for (int i = 0; i < widgets.length; i++) {
			Widget widget = widgets[i];
			Renderer widgetRenderer = widget.getRenderer();
			int widgetMargin = widgetRenderer==null ? 0 : widgetRenderer.getMargin();
			widget.validate(0, heightHint < (widgetMargin * 2) ? 0 : heightHint - (widgetMargin * 2));
			widget.setBounds(totalWidth + myPadding + widgetMargin, myPadding + widgetMargin, widget.getPreferredWidth(), widget.getPreferredHeight());
			totalWidth += widget.getPreferredWidth() + (widgetMargin * 2) + myPadding;
			maxHeight = Math.max(maxHeight, widget.getPreferredHeight() + (widgetMargin * 2) + (myPadding * 2));
		}
		setPreferredSize(totalWidth + myPadding, maxHeight);
	}
}
