/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex14;

import ej.microui.Colors;
import ej.microui.io.GraphicsContext;
import ej.mwt.Panel;
import ej.mwt.Renderable;
import ej.mwt.rendering.Look;
import ej.mwt.rendering.Renderer;

public class PanelRenderer extends Renderer {
	
	public Class getManagedType() {
		return Panel.class;
	}

	public void render(GraphicsContext g, Renderable renderable) {
		Panel panel = (Panel) renderable;
		int width = renderable.getWidth();
		int height = renderable.getHeight();
		g.setColor(panel.isActive()?Colors.GREEN:Colors.YELLOW);
		g.fillRect(0, 0, width, height);
		g.setColor(getLook().getProperty(Look.GET_BORDER_COLOR_DEFAULT));
		for (int inset = 0; inset < 3; inset++) {
			g.drawRect(inset, inset, width-1-(inset*2), height-1-(inset*2));
		}
	}

	public int getPadding() {
		return 5;
	}
}
