/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex15;

import ej.microui.Listener;
import ej.microui.MicroUI;
import ej.mwt.Desktop;
import ej.mwt.MWT;
import ej.mwt.Panel;

public class Ex15 {

	public static void main(String[] args) {
		MicroUI.errorLog(true);
		MWT.RenderingContext.add(new TutorialTheme());
		Desktop desktop = new Desktop();
		Panel panel = new Panel();
		Scale scale = new Scale(0, 100, ScaleRenderer.STYLE);
		Scale scaleReadout = new Scale(scale.getBoundMin(), scale.getBoundMax(), NumericReadoutRenderer.STYLE);
		IntHolderAndListener model = new IntHolderAndListener(0);
		scale.setListener(model);
		model.addListener(scaleReadout);
		model.addListener(scale);
		model.addListener(new Listener() {
			public void performAction(int value) {
				System.out.println("Value is now " + value);
			}
			public void performAction() {}
			public void performAction(int value, Object object) {}
		});
		HorizontalStack composite = new HorizontalStack();
		composite.add(scale);
		composite.add(scaleReadout);
		panel.setWidget(composite);
		panel.show(desktop);
		desktop.show();
	}
}
