/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex15;

import ej.microui.Colors;
import ej.microui.io.DisplayFont;
import ej.mwt.rendering.Look;

public class TutorialLook implements Look {
	private static final DisplayFont[] fonts;

	static {
		fonts = new DisplayFont[]{
				DisplayFont.getDefaultFont()};
	}

	public DisplayFont[] getFonts() {
		return fonts;
	}

	public int getProperty(int resource) {
		switch(resource) {
		// Borders
		// use this for all borders
		case Look.GET_BORDER_COLOR_DEFAULT:
			return Colors.BLACK;

		// Backgrounds
		// use this for desktop background
		case Look.GET_BACKGROUND_COLOR_DEFAULT:
			return Colors.GRAY;
		// use this for the background of widgets
		// that are enabled and not selected
		case Look.GET_BACKGROUND_COLOR_CONTENT:
			return Colors.WHITE;
		// use this for the background of widgets
		// that are disabled and not selected
		case Look.GET_BACKGROUND_COLOR_DISABLED:
			return 0xAAAAAA; // light gray
		// use this for the background of widgets
		// that are disabled and selected
		case Look.GET_BACKGROUND_COLOR_FOCUSED:
			return 0xAA0000; // dull red
		// use this for widgets that are
		// enabled and selected
		case Look.GET_BACKGROUND_COLOR_SELECTION:
			return Colors.RED;

		// Foregrounds
		// use this for all foreground
		case Look.GET_FOREGROUND_COLOR_DEFAULT:
			return Colors.BLACK;

		// Font indexes
		case Look.GET_FONT_INDEX_DEFAULT:
			return 0;

		default:
			throw new IllegalArgumentException();
		}
	}
}
