/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex16;

import com.is2t.mwt.tutorial.ex16.widget.HorizontalStack;
import com.is2t.mwt.tutorial.ex16.widget.Label;
import com.is2t.mwt.tutorial.ex16.widget.ToggleButton;
import com.is2t.mwt.tutorial.ex16.widget.TutorialTheme;
import com.is2t.mwt.tutorial.ex16.widget.VerticalStack;

import ej.microui.MicroUI;
import ej.mwt.Composite;
import ej.mwt.Desktop;
import ej.mwt.MWT;
import ej.mwt.Panel;

public class Ex16 {

	public static void main(String[] args) {
		SpringSimulation leftSpringSim = new SpringSimulation();
		leftSpringSim.setPosition(70);
		SpringSimulation rightSpringSim = new SpringSimulation();
		rightSpringSim.setPosition(70);
		SpringSimulationRunner runner = SpringSimulationRunner.getInstance();
		runner.add(leftSpringSim);
		runner.add(rightSpringSim);
		IntHolderAndListener onOffState = new IntHolderAndListener(1);
		onOffState.addListener(runner);

		SpringGUI leftSpringGUI = new SpringGUI(leftSpringSim, false);
		SpringGUI rightSpringGUI = new SpringGUI(rightSpringSim, true);
		Label title = new Label("Spring Simulation Lab");
		ToggleButton onOffButton = new ToggleButton("Start/Stop");
		onOffButton.setListener(onOffState);
		onOffState.addListener(leftSpringGUI);
		onOffState.addListener(rightSpringGUI);
		onOffState.set(0);

		Composite rows = new VerticalStack();
		rows.add(title);
		Composite springGuis = new HorizontalStack();
		springGuis.add(leftSpringGUI);
		springGuis.add(rightSpringGUI);
		rows.add(springGuis);
		rows.add(onOffButton);

		MicroUI.errorLog(true);
		MWT.RenderingContext.add(new TutorialTheme());
		Desktop desktop = new Desktop();
		rows.validate(0, 0);
		Panel panel = new Panel(0, 0, rows.getPreferredWidth(), desktop.getHeight());
		panel.setWidget(rows);
		panel.show(desktop);
		desktop.show();
	}
}
