/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex16;

import com.is2t.mwt.tutorial.ex16.widget.HangingBoxRenderer;
import com.is2t.mwt.tutorial.ex16.widget.HorizontalStack;
import com.is2t.mwt.tutorial.ex16.widget.Label;
import com.is2t.mwt.tutorial.ex16.widget.NumericReadoutRenderer;
import com.is2t.mwt.tutorial.ex16.widget.Scale;
import com.is2t.mwt.tutorial.ex16.widget.ScaleRenderer;
import com.is2t.mwt.tutorial.ex16.widget.VerticalStack;

import ej.microui.Listener;

public class SpringGUI extends HorizontalStack implements Listener {
	
	private Scale springWidget;
	private Scale massSlider;

	public SpringGUI(final SpringSimulation spring, boolean springOnLeft) {
		super();
		springWidget = new Scale(-spring.getPosition(), spring.getPosition(), HangingBoxRenderer.STYLE);
		springWidget.setValue(spring.getPosition());
		spring.addListener(springWidget);
		springWidget.setListener(spring);
		massSlider = new Scale(1, spring.getMass().get(), ScaleRenderer.STYLE);
		Scale massReadout = new Scale(massSlider.getBoundMin(), massSlider.getBoundMax(), NumericReadoutRenderer.STYLE);
		massSlider.setValue(spring.getMass().get());
		massSlider.setListener(spring.getMass());
		massReadout.setValue(massSlider.getValue());
		massReadout.setEnabled(false);
		spring.getMass().addListener(massReadout);
		Label massLabel = new Label("Mass");
		VerticalStack verticalStack = new VerticalStack();
		verticalStack.add(massLabel);
		verticalStack.add(massReadout);
		verticalStack.add(massSlider);
		if (springOnLeft) {
			add(springWidget);
			add(verticalStack);
		} else {
			add(verticalStack);
			add(springWidget);
		}
	}

	/**
	 * React to a change in the start/stop state.
	 * @param value 0 = stopped, non-0 = running
	 */
	public void performAction(int value) {
		massSlider.setEnabled(value==0?true:false);
		springWidget.setEnabled(value==0?true:false);
	}

	public void performAction() {}
	public void performAction(int value, Object object) {}
}
