/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex16;

import java.util.Enumeration;
import java.util.Vector;

import ej.bon.Timer;
import ej.bon.TimerTask;
import ej.microui.Listener;
import ej.microui.io.Display;

/**
 * A singleton that steps one or more simulations using a timer task
 */
public class SpringSimulationRunner implements Listener {
	
	private static SpringSimulationRunner theInstance;
	private Vector simulations = new Vector();
	private boolean running;
	
	static {
		theInstance = new SpringSimulationRunner();
	}

	public static SpringSimulationRunner getInstance() {
		return theInstance;
	}

	public void add(SpringSimulation springSimulation) {
		simulations.addElement(springSimulation);
	}

	public void performAction(int value) {
		running = value!=0;
	}

	public void performAction() {}
	public void performAction(int value, Object object) {}

	private SpringSimulationRunner() {
		TimerTask task = new TimerTask() {
			public void run() {
				if (!running) return;
				Display.getDefaultDisplay().callSerially(new Runnable() {
					public void run() {
						Enumeration elements = simulations.elements();
						while (elements.hasMoreElements()) {
							SpringSimulation sim = (SpringSimulation) elements.nextElement();
							sim.step();
						}
					}
				});
			}};
			new Timer().schedule(task , 50, 50);
	}
}
