/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex16.widget;

import ej.microui.Command;
import ej.microui.Event;
import ej.microui.Listener;
import ej.microui.io.Pointer;

public class Button extends TextHolder {

	private Listener listener;

	public Button(String text) {
		super(text);
	}
	
	public void setListener(Listener listener) {
		this.listener = listener;
	}

	public boolean handleEvent(int event) {
		int type = Event.getType(event);
		if (type == Event.POINTER) {
			int action = Pointer.getAction(event);
			if (action == Pointer.RELEASED) {
				if (listener != null)
					listener.performAction();
				return true;
			}
		}
		if(type == Event.COMMAND) {
			int command = Event.getData(event);
			if (command == Command.SELECT) {
				if (listener != null)
					listener.performAction();
				return true;
			}
		}
		return super.handleEvent(event);
	}
}