/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex16.widget;

import ej.microui.io.GraphicsContext;
import ej.mwt.Renderable;
import ej.mwt.Widget;
import ej.mwt.rendering.Look;

public class ButtonRenderer extends TutorialRenderer {

	public Class getManagedType() {
		return Button.class;
	}

	public int getPreferredContentWidth(Widget widget) {
		Button button = (Button) widget;
		String text = button.getText();
		return getNormalFont().stringWidth(text);
	}

	public int getPreferredContentHeight(Widget widget) {
		return getNormalFont().getHeight();
	}

	public void render(GraphicsContext g, Renderable renderable) {
		Button button = (Button) renderable;
		fillBackground(g, button);
		g.setColor(getLook().getProperty(Look.GET_FOREGROUND_COLOR_DEFAULT));
		g.setFont(getNormalFont());
		g.drawString(button.getText(),
				button.getWidth() / 2, button.getHeight() / 2,
				GraphicsContext.HCENTER | GraphicsContext.VCENTER);
		drawFocusOutline(g, button, 1);
	}
}
