/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex16.widget;

import ej.microui.io.GraphicsContext;
import ej.mwt.Renderable;
import ej.mwt.Widget;
import ej.mwt.rendering.Look;

public class LabelRenderer extends TutorialRenderer {
	
	public Class getManagedType() {
		return Label.class;
	}

	public int getPreferredContentWidth(Widget widget) {
		TextHolder label = (TextHolder) widget;
		String text = label.getText();
		return getNormalFont().stringWidth(text);
	}

	public int getPreferredContentHeight(Widget widget) {
		return getNormalFont().getHeight();
	}

	public void render(GraphicsContext g, Renderable renderable) {
		TextHolder label = (TextHolder)renderable;
		fillBackground(g, label);
		g.setColor(getLook().getProperty(Look.GET_FOREGROUND_COLOR_DEFAULT));
		g.setFont(getNormalFont());
		g.drawString(label.getText(), label.getWidth() / 2, label.getHeight() / 2,
				GraphicsContext.HCENTER | GraphicsContext.VCENTER);
	}
}
