/**
 * Java
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.mwt.tutorial.ex16.widget;

import ej.microui.io.DisplayFont;
import ej.microui.io.GraphicsContext;
import ej.mwt.Widget;
import ej.mwt.rendering.Look;
import ej.mwt.rendering.WidgetRenderer;

public abstract class TutorialRenderer extends WidgetRenderer {

	public TutorialRenderer() {
		super();
	}

	public int getMargin() {
		return 2;
	}

	public int getPadding() {
		return 4;
	}

	protected DisplayFont getNormalFont() {
		return getLook().getFonts()[getLook().getProperty(Look.GET_FONT_INDEX_DEFAULT)];
	}

	protected void fillBackground(GraphicsContext g, Widget widget) {
		if (!widget.isTransparent()) {
			g.setColor(getBackgroundColor(widget));
			g.fillRect(0, 0, widget.getWidth(), widget.getHeight());
		}
	}

	protected void drawFocusOutline(GraphicsContext g, Widget widget, int inset) {
		if (widget.hasFocus()) {
			g.setStrokeStyle(GraphicsContext.DOTTED);
			g.setColor(getLook().getProperty(Look.GET_BORDER_COLOR_DEFAULT));
			g.drawRect(inset, inset, widget.getWidth() - (inset*2 + 1), widget.getHeight() - (inset*2 + 1));
		}
	}

	protected int getBackgroundColor(Widget widget) {
		int property = widget.isEnabled() ? Look.GET_BACKGROUND_COLOR_CONTENT
				: Look.GET_BACKGROUND_COLOR_DISABLED;
		return getLook().getProperty(property);
	}

}